/* X Unicode Library ver.0.2.7
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * $xunicode: xuarray.h,v 1.6.0 2000/07/07 20:54:03 Toshihiro Inoue Exp $
 */

#ifndef _XUARRAY_H_
#define _XUARRAY_H_

#include "xuobject.h"

class XUArray: public XUObject
{
public:
  XUArray();
  ~XUArray();
  void clear();
  void resize(int sz);
  bool empty();
  int count();
  void add(XUObject* d);
  XUObject* operator[](int n);
  void operator=(const XUArray& a);
  XUObject* first();
  XUObject* last();
  XUObject* current();
  XUObject* next();
  XUObject* prev();
  
private:
  void __init_class__();
  
protected:
  XUObject** data;
  int bufLen;
  int mCount;
  int cur;
};

#endif // _XUARRAY_H_
