/* X Unicode Library ver.0.2.7
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * $xunicode: xucodec.h,v 1.26.2 2000/07/07 20:54:03 Toshihiro Inoue Exp $
 */

#ifndef _XUCODEC_H_
#define _XUCODEC_H_

#include "xucstring.h"
#include "xucstring.h"
#include "xustring.h"
#include "xustring.h"

#include "xuobject.h"

/**
  文字コード変換の基礎となるクラス
  UTF-8 を扱う
*/

class XUCodec: public XUObject
{
public:
  XUCodec();
  virtual const char* name();
  static XUString uni(const char* s);
  virtual XUString unicode(const char* s);
  static XUCString enc(const XUString& s);
  virtual XUCString encode(const XUString& s);
  static int enc(int u);
  static char chkCode(int u);
  static const char* codeSet(char enc);
  static int len(const char* s, int max = 3);
  static int lenRev(const char* s, int max = 3);
  
private:
  void __init_class__();
};

#endif // _XUCODEC_H_
