/* X Unicode Library ver.0.2.7
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * $xunicode: xufont.h,v 1.20.8 2000/07/07 20:54:04 Toshihiro Inoue Exp $
 */

#ifndef _XUFONT_H_
#define _XUFONT_H_

class XUFontSet;
class XUFontStruct;
class XUString;

#include <X11/Xlib.h>

class XUFont
{
public:
  XUFont();
  XUFont(const char* n);
  XUFont(const XUFont& f);
  void name(const char* n);
  XUFontStruct* font(const char* enc) const;
  XUFontStruct* font() const;
  XFontSet fontSet();
  operator XFontStruct*() const;
  bool isUnicode() const;
  void operator=(const XUFont& f);
  bool operator==(const XUFont& f) const;
  int ascent() const;
  int descent() const;
  int height() const;
  int textWidth(const XUString& s) const;
  void print(Window w, GC gc, int x, int y, const XUString& s, bool flg = false);
  
private:
  void __init_class__();
  int textWidth(char c, const XChar2b* s, int l) const;
  void print(Window w, GC gc, int* x, int* y, char c, const XChar2b* s, int l, bool flg);
  void print(Window w, GC gc, int* x, int* y, XUFontStruct* f, const XChar2b* s, int l, bool flg);
  
private:
  XUFontStruct* mFont;
  XUFontSet* mFontSet;
  bool uni;
};

#endif // _XUFONT_H_
