/* X Unicode Library ver.0.2.7
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * $xunicode: xufontset.h,v 1.10.2 2000/07/07 20:54:04 Toshihiro Inoue Exp $
 */

#ifndef _XUFONTSET_H_
#define _XUFONTSET_H_

#include <X11/Xlib.h>

#include "xuobject.h"

class XUFontSet: public XUObject
{
public:
  XUFontSet(const char* n);
  ~XUFontSet();
  XFontSet font() const;
  int ascent() const;
  int descent() const;
  int height() const;
  int textWidth(const char* s) const;
  
private:
  void __init_class__();
  void setProp();
  
private:
  XFontSet mFont;
  int mAscent;
  int mDescent;
};

#endif // _XUFONTSET_H_
