/* X Unicode Library ver.0.2.7
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * $xunicode: xufontstruct.h,v 1.6.0 2000/07/07 20:54:04 Toshihiro Inoue Exp $
 */

#ifndef _XUFONTSTRUCT_H_
#define _XUFONTSTRUCT_H_

#include "xucstring.h"
#include "xufontname.h"

#include <X11/Xlib.h>

#include "xuobject.h"

class XUFontStruct: public XUObject
{
public:
  XUFontStruct();
  XUFontStruct(const char* n);
  ~XUFontStruct();
  void font(const char* n);
  XFontStruct* font() const;
  XUCString prop(const char* n);
  int ascent() const;
  int descent() const;
  int height() const;
  int textWidth(const XChar2b* s, int l) const;
  
private:
  void __init_class__();
  bool isStr(const XUCString& n);
  
public:
  XUFontName name;
  
private:
  XFontStruct* mFont;
};

#endif // _XUFONTSTRUCT_H_
