/* X Unicode Library ver.0.2.7
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * $xunicode: xulib.h,v 1.38.7 2000/07/07 20:54:04 Toshihiro Inoue Exp $
 */

#ifndef _XULIB_H_
#define _XULIB_H_

class XUCodec;
class XUFontMgr;
class XUFontSet;
class XUFontStruct;

#include "xucstring.h"
#include "xucstring.h"
#include "xucstring.h"
#include "xucstring.h"
#include "xudict.h"
#include "xudict.h"
#include "xudict.h"
#include "xustrarray.h"
#include "xustrdict.h"

#include <X11/Xlib.h>

class  XULib;
extern XULib xulib;

class XULib
{
public:
  XULib();
  ~XULib();
  Display* display() const;
  unsigned long black() const;
  unsigned long white() const;
  Window root() const;
  XIM xim() const;
  XUCString lang();
  XUCodec* codec();
  XUCString getSet(const XUCString& enc);
  XUFontStruct* font(XUFontStruct* fs, const char* enc, bool flg = true);
  XUFontStruct* fontStruct(const char* n, bool flg);
  XUFontSet* fontSet(XUFontStruct* f);
  bool useUnicode();
  
private:
  void __init_class__();
  void init();
  void initLocale();
  void initEnc();
  void openIM();
  void readRc();
  bool readRc(const char* fn);
  void setFontRc(XUCString d);
  void addSet(const XUCString& enc, const XUCString& n);
  XUFontMgr* fontMgr(const char* n);
  
private:
  Display* mDisplay;
  Window mRoot;
  int screen;
  unsigned long mBlack;
  unsigned long mWhite;
  XIM mXIM;
  XUDict fonts;
  XUDict fontMgrs;
  XUDict fontSets;
  XUStrDict mSet;
  XUCString mLang;
  XUStrArray mEncs;
  XUCodec* mCodec;
  bool uni;
};

#endif // _XULIB_H_
