/* X Unicode Library ver.0.2.7
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * $xunicode: xustring.h,v 1.27.1 2000/07/07 20:54:03 Toshihiro Inoue Exp $
 */

#ifndef _XUSTRING_H_
#define _XUSTRING_H_

#include "xuobject.h"

/**
  Unicodeで格納する文字列クラス
*/

class XUString: public XUObject
{
public:
  XUString();
  XUString(const char* s);
  XUString(const XUString& s);
  XUString(int c);
  ~XUString();
  void clear();
  void erase();
  int len() const;
  bool empty() const;
  const char* codeSet() const;
  void operator=(const XUString& s);
  void operator=(const char* s);
  void operator+=(const XUString& s);
  void operator+=(int c);
  void operator-=(int l);
  XUString operator+(const XUString& s);
  XUString operator+(int c);
  int operator[](int n);
  operator const int*() const;
  int find(int c, int p = 0) const;
  int findRev(int c, int p = -1) const;
  XUString left(int l) const;
  XUString mid(int p, int l = -1) const;
  XUString right(int l) const;
  
private:
  void __init_class__();
  void resize(int sz);
  
private:
  int* str;
  char* code;
  int length;
  int bufLen;
};

#endif // _XUSTRING_H_
