/* X Unicode Library ver.0.2.7
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * $xunicode: xuwindow.h,v 1.39.0 2000/07/07 20:54:04 Toshihiro Inoue Exp $
 */

#ifndef _XUWINDOW_H_
#define _XUWINDOW_H_

#include "xufont.h"
#include "xufont.h"
#include "xufont.h"
#include "xuic.h"
#include "xustring.h"
#include "xustring.h"

#include <X11/Xlib.h>

#include "xuobject.h"

class XUWindow: public XUObject
{
public:
  XUWindow();
  XUWindow(Window win, GC gc);
  virtual ~XUWindow();
  void show();
  void handle(const XEvent* e);
  bool isDelete(const XEvent* e);
  operator Window();
  void font(XUFont f);
  XUFont font();
  GC gc();
  void label(const XUString& l);
  XUString label() const;
  bool createIC();
  XUIC* ic();
  void moveIC();
  int curX() const;
  int curY() const;
  void curXY(int x, int y);
  void print(const XUString& s, bool flg = false);
  void printn(const XUString& s, bool flg = false);
  void nextLine();
  
protected:
  virtual void focusIn();
  virtual void focusOut();
  
private:
  void __init_class__();
  void init();
  
private:
  Window mWin;
  XUFont mFont;
  GC mGC;
  XUIC mXIC;
  int mCurX;
  int mCurY;
  bool autoDelete;
  Atom atmDelete;
  XUString mLabel;
};

#endif // _XUWINDOW_H_
